# vrchat_dart_generated (EXPERIMENTAL)
![VRChat API Banner](https://vrchatapi.github.io/assets/img/api_banner_1500x400.png)

# VRChat API Documentation
This project is an [OPEN Open Source Project](https://openopensource.org)

Individuals making significant and valuable contributions are given
commit-access to the project to contribute as they see fit. This project
is more like an open wiki than a standard guarded open source project.

## Disclaimer

This is the official response of the VRChat Team (from Tupper more specifically) on the usage of the VRChat API.

> **Use of the API using applications other than the approved methods (website, VRChat application) are not officially supported. You may use the API for your own application, but keep these guidelines in mind:**
> * We do not provide documentation or support for the API.
> * Do not make queries to the API more than once per 60 seconds.
> * Abuse of the API may result in account termination.
> * Access to API endpoints may break at any given time, with no warning.

As stated, this documentation was not created with the help of the official VRChat team. Therefore this documentation is not an official documentation of the VRChat API and may not be always up to date with the latest versions. If you find that a page or endpoint is not longer valid please create an issue and tell us so we can fix it.

## Get in touch with us!

[https://discord.gg/qjZE9C9fkB#vrchat-api](https://discord.gg/qjZE9C9fkB)

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Build package: org.openapitools.codegen.languages.DartDioNextClientCodegen
For more information, please visit [https://github.com/VRChatAPI](https://github.com/VRChatAPI)

## Requirements

* Dart 2.12.0 or later OR Flutter 1.26.0 or later
* Dio 4.0.0+

## Installation & Usage

### pub.dev
To use the package from [pub.dev](https://pub.dev), please include the following in pubspec.yaml
```yaml
dependencies:
  vrchat_dart_generated: 1.3.7
```

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```yaml
dependencies:
  vrchat_dart_generated:
    git:
      url: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      #ref: main
```

### Local development
To use the package from your local drive, please include the following in pubspec.yaml
```yaml
dependencies:
  vrchat_dart_generated:
    path: /path/to/vrchat_dart_generated
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:vrchat_dart_generated/vrchat_dart_generated.dart';


final api = VrchatDartGenerated().getAuthenticationApi();
final String userId = userId_example; // String | 

try {
    final response = await api.deleteUserById(userId);
    print(response);
} catch on DioError (e) {
    print("Exception when calling AuthenticationApi->deleteUserById: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://api.vrchat.cloud/api/1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
[*AuthenticationApi*](doc/AuthenticationApi.md) | [**deleteUserById**](doc/AuthenticationApi.md#deleteuserbyid) | **PUT** /user/{userId}/delete | Delete User
[*AuthenticationApi*](doc/AuthenticationApi.md) | [**getCurrentUser**](doc/AuthenticationApi.md#getcurrentuser) | **GET** /auth/user | Login and/or Get Current User Info
[*AuthenticationApi*](doc/AuthenticationApi.md) | [**logout**](doc/AuthenticationApi.md#logout) | **PUT** /logout | Logout
[*AuthenticationApi*](doc/AuthenticationApi.md) | [**verify2FA**](doc/AuthenticationApi.md#verify2fa) | **POST** /auth/twofactorauth/totp/verify | Verify 2FA code
[*AuthenticationApi*](doc/AuthenticationApi.md) | [**verifyAuthToken**](doc/AuthenticationApi.md#verifyauthtoken) | **GET** /auth | Verify Auth Token
[*AuthenticationApi*](doc/AuthenticationApi.md) | [**verifyRecoveryCode**](doc/AuthenticationApi.md#verifyrecoverycode) | **POST** /auth/twofactorauth/otp/verify | Verify 2FA code with Recovery code
[*AvatarsApi*](doc/AvatarsApi.md) | [**createAvatar**](doc/AvatarsApi.md#createavatar) | **POST** /avatars | Create Avatar
[*AvatarsApi*](doc/AvatarsApi.md) | [**deleteAvatar**](doc/AvatarsApi.md#deleteavatar) | **DELETE** /avatars/{avatarId} | Delete Avatar
[*AvatarsApi*](doc/AvatarsApi.md) | [**getAvatar**](doc/AvatarsApi.md#getavatar) | **GET** /avatars/{avatarId} | Get Avatar
[*AvatarsApi*](doc/AvatarsApi.md) | [**getFavoritedAvatars**](doc/AvatarsApi.md#getfavoritedavatars) | **GET** /avatars/favorites | List Favorited Avatars
[*AvatarsApi*](doc/AvatarsApi.md) | [**searchAvatars**](doc/AvatarsApi.md#searchavatars) | **GET** /avatars | Search Avatars
[*AvatarsApi*](doc/AvatarsApi.md) | [**selectAvatar**](doc/AvatarsApi.md#selectavatar) | **PUT** /avatars/{avatarId}/select | Select Avatar
[*AvatarsApi*](doc/AvatarsApi.md) | [**updateAvatar**](doc/AvatarsApi.md#updateavatar) | **PUT** /avatars/{avatarId} | Update Avatar
[*FavoritesApi*](doc/FavoritesApi.md) | [**addFavorite**](doc/FavoritesApi.md#addfavorite) | **POST** /favorites | Add Favorite
[*FavoritesApi*](doc/FavoritesApi.md) | [**clearFavoriteGroup**](doc/FavoritesApi.md#clearfavoritegroup) | **DELETE** /favorite/group/{favoriteGroupType}/{favoriteGroupName}/{userId} | Clear Favorite Group
[*FavoritesApi*](doc/FavoritesApi.md) | [**getFavorite**](doc/FavoritesApi.md#getfavorite) | **GET** /favorites/{favoriteId} | Show Favorite
[*FavoritesApi*](doc/FavoritesApi.md) | [**getFavoriteGroup**](doc/FavoritesApi.md#getfavoritegroup) | **GET** /favorite/group/{favoriteGroupType}/{favoriteGroupName}/{userId} | Show Favorite Group
[*FavoritesApi*](doc/FavoritesApi.md) | [**getFavoriteGroups**](doc/FavoritesApi.md#getfavoritegroups) | **GET** /favorite/groups | List Favorite Groups
[*FavoritesApi*](doc/FavoritesApi.md) | [**getFavorites**](doc/FavoritesApi.md#getfavorites) | **GET** /favorites | List Favorites
[*FavoritesApi*](doc/FavoritesApi.md) | [**removeFavorite**](doc/FavoritesApi.md#removefavorite) | **DELETE** /favorites/{favoriteId} | Remove Favorite
[*FavoritesApi*](doc/FavoritesApi.md) | [**updateFavoriteGroup**](doc/FavoritesApi.md#updatefavoritegroup) | **PUT** /favorite/group/{favoriteGroupType}/{favoriteGroupName}/{userId} | Update Favorite Group
[*FilesApi*](doc/FilesApi.md) | [**createFile**](doc/FilesApi.md#createfile) | **POST** /file | Create File
[*FilesApi*](doc/FilesApi.md) | [**createFileVersion**](doc/FilesApi.md#createfileversion) | **POST** /file/{fileId} | Create File Version
[*FilesApi*](doc/FilesApi.md) | [**deleteFile**](doc/FilesApi.md#deletefile) | **DELETE** /file/{fileId} | Delete File
[*FilesApi*](doc/FilesApi.md) | [**deleteFileVersion**](doc/FilesApi.md#deletefileversion) | **DELETE** /file/{fileId}/{versionId} | Delete File Version
[*FilesApi*](doc/FilesApi.md) | [**downloadFileVersion**](doc/FilesApi.md#downloadfileversion) | **GET** /file/{fileId}/{versionId} | Download File Version
[*FilesApi*](doc/FilesApi.md) | [**finishFileDataUpload**](doc/FilesApi.md#finishfiledataupload) | **PUT** /file/{fileId}/{versionId}/{fileType}/finish | Finish FileData Upload
[*FilesApi*](doc/FilesApi.md) | [**getFile**](doc/FilesApi.md#getfile) | **GET** /file/{fileId} | Show File
[*FilesApi*](doc/FilesApi.md) | [**getFileDataUploadStatus**](doc/FilesApi.md#getfiledatauploadstatus) | **GET** /file/{fileId}/{versionId}/{fileType}/status | Check FileData Upload Status
[*FilesApi*](doc/FilesApi.md) | [**getFiles**](doc/FilesApi.md#getfiles) | **GET** /files | List Files
[*FilesApi*](doc/FilesApi.md) | [**startFileDataUpload**](doc/FilesApi.md#startfiledataupload) | **PUT** /file/{fileId}/{versionId}/{fileType}/start | Start FileData Upload
[*FriendsApi*](doc/FriendsApi.md) | [**deleteFriendRequest**](doc/FriendsApi.md#deletefriendrequest) | **DELETE** /user/{userId}/friendRequest | Delete Friend Request
[*FriendsApi*](doc/FriendsApi.md) | [**friend**](doc/FriendsApi.md#friend) | **POST** /user/{userId}/friendRequest | Send Friend Request
[*FriendsApi*](doc/FriendsApi.md) | [**getFriendStatus**](doc/FriendsApi.md#getfriendstatus) | **GET** /user/{userId}/friendStatus | Check Friend Status
[*FriendsApi*](doc/FriendsApi.md) | [**getFriends**](doc/FriendsApi.md#getfriends) | **GET** /auth/user/friends | List Friends
[*FriendsApi*](doc/FriendsApi.md) | [**unfriend**](doc/FriendsApi.md#unfriend) | **DELETE** /auth/user/friends/{userId} | Unfriend
[*NotificationsApi*](doc/NotificationsApi.md) | [**acceptFriendRequest**](doc/NotificationsApi.md#acceptfriendrequest) | **PUT** /auth/user/notifications/{notificationId}/accept | Accept Friend Request
[*NotificationsApi*](doc/NotificationsApi.md) | [**clearNotifications**](doc/NotificationsApi.md#clearnotifications) | **PUT** /auth/user/notifications/clear | Clear All Notifications
[*NotificationsApi*](doc/NotificationsApi.md) | [**deleteNotification**](doc/NotificationsApi.md#deletenotification) | **PUT** /auth/user/notifications/{notificationId}/hide | Delete Notification
[*NotificationsApi*](doc/NotificationsApi.md) | [**getNotifications**](doc/NotificationsApi.md#getnotifications) | **GET** /auth/user/notifications | List Notifications
[*NotificationsApi*](doc/NotificationsApi.md) | [**markNotificationAsRead**](doc/NotificationsApi.md#marknotificationasread) | **PUT** /auth/user/notifications/{notificationId}/see | Mark As Read
[*PlayermoderationApi*](doc/PlayermoderationApi.md) | [**clearAllPlayerModerations**](doc/PlayermoderationApi.md#clearallplayermoderations) | **DELETE** /auth/user/playermoderations | Clear All Player Moderations
[*PlayermoderationApi*](doc/PlayermoderationApi.md) | [**deletePlayerModeration**](doc/PlayermoderationApi.md#deleteplayermoderation) | **DELETE** /auth/user/playermoderations/{playerModerationId} | Delete Player Moderation
[*PlayermoderationApi*](doc/PlayermoderationApi.md) | [**getPlayerModeration**](doc/PlayermoderationApi.md#getplayermoderation) | **GET** /auth/user/playermoderations/{playerModerationId} | Get Player Moderation
[*PlayermoderationApi*](doc/PlayermoderationApi.md) | [**getPlayerModerations**](doc/PlayermoderationApi.md#getplayermoderations) | **GET** /auth/user/playermoderations | Search Player Moderations
[*PlayermoderationApi*](doc/PlayermoderationApi.md) | [**moderateUser**](doc/PlayermoderationApi.md#moderateuser) | **POST** /auth/user/playermoderations | Moderate User
[*PlayermoderationApi*](doc/PlayermoderationApi.md) | [**unmoderateUser**](doc/PlayermoderationApi.md#unmoderateuser) | **PUT** /auth/user/unplayermoderate | Unmoderate User
[*SystemApi*](doc/SystemApi.md) | [**getConfig**](doc/SystemApi.md#getconfig) | **GET** /config | Fetch API Config
[*SystemApi*](doc/SystemApi.md) | [**getCurrentOnlineUsers**](doc/SystemApi.md#getcurrentonlineusers) | **GET** /visits | Current Online Users
[*SystemApi*](doc/SystemApi.md) | [**getHealth**](doc/SystemApi.md#gethealth) | **GET** /health | Check API Health
[*SystemApi*](doc/SystemApi.md) | [**getSystemTime**](doc/SystemApi.md#getsystemtime) | **GET** /time | Current System Time
[*UsersApi*](doc/UsersApi.md) | [**getUser**](doc/UsersApi.md#getuser) | **GET** /users/{userId} | Get User by ID
[*UsersApi*](doc/UsersApi.md) | [**getUserByName**](doc/UsersApi.md#getuserbyname) | **GET** /users/{username}/name | Get User by Username
[*UsersApi*](doc/UsersApi.md) | [**searchActiveUsers**](doc/UsersApi.md#searchactiveusers) | **GET** /users/active | Search Active Users
[*UsersApi*](doc/UsersApi.md) | [**searchUsers**](doc/UsersApi.md#searchusers) | **GET** /users | Search All Users
[*UsersApi*](doc/UsersApi.md) | [**updateUser**](doc/UsersApi.md#updateuser) | **PUT** /users/{userId} | Update User Info
[*WorldsApi*](doc/WorldsApi.md) | [**createWorld**](doc/WorldsApi.md#createworld) | **POST** /worlds | Create World
[*WorldsApi*](doc/WorldsApi.md) | [**deleteWorld**](doc/WorldsApi.md#deleteworld) | **DELETE** /worlds/{worldId} | Delete World
[*WorldsApi*](doc/WorldsApi.md) | [**getActiveWorlds**](doc/WorldsApi.md#getactiveworlds) | **GET** /worlds/active | List Active Worlds
[*WorldsApi*](doc/WorldsApi.md) | [**getFavoritedWorlds**](doc/WorldsApi.md#getfavoritedworlds) | **GET** /worlds/favorites | List Favorited Worlds
[*WorldsApi*](doc/WorldsApi.md) | [**getRecentWorlds**](doc/WorldsApi.md#getrecentworlds) | **GET** /worlds/recent | List Recent Worlds
[*WorldsApi*](doc/WorldsApi.md) | [**getWorld**](doc/WorldsApi.md#getworld) | **GET** /worlds/{worldId} | Get World by ID
[*WorldsApi*](doc/WorldsApi.md) | [**getWorldInstance**](doc/WorldsApi.md#getworldinstance) | **GET** /worlds/{worldId}/{instanceId} | Get World Instance
[*WorldsApi*](doc/WorldsApi.md) | [**getWorldMetadata**](doc/WorldsApi.md#getworldmetadata) | **GET** /worlds/{worldId}/metadata | Get World Metadata
[*WorldsApi*](doc/WorldsApi.md) | [**getWorldPublishStatus**](doc/WorldsApi.md#getworldpublishstatus) | **GET** /worlds/{worldId}/publish | Get World Publish Status
[*WorldsApi*](doc/WorldsApi.md) | [**publishWorld**](doc/WorldsApi.md#publishworld) | **PUT** /worlds/{worldId}/publish | Publish World
[*WorldsApi*](doc/WorldsApi.md) | [**searchWorlds**](doc/WorldsApi.md#searchworlds) | **GET** /worlds | Search All Worlds
[*WorldsApi*](doc/WorldsApi.md) | [**unpublishWorld**](doc/WorldsApi.md#unpublishworld) | **DELETE** /worlds/{worldId}/publish | Unpublish World
[*WorldsApi*](doc/WorldsApi.md) | [**updateWorld**](doc/WorldsApi.md#updateworld) | **PUT** /worlds/{worldId} | Update World


## Documentation For Models

 - [Avatar](doc/Avatar.md)
 - [AvatarUnityPackageUrlObject](doc/AvatarUnityPackageUrlObject.md)
 - [Config](doc/Config.md)
 - [ConfigAnnouncements](doc/ConfigAnnouncements.md)
 - [ConfigDownloadUrls](doc/ConfigDownloadUrls.md)
 - [ConfigDynamicWorldRows](doc/ConfigDynamicWorldRows.md)
 - [ConfigEvents](doc/ConfigEvents.md)
 - [CurrentUser](doc/CurrentUser.md)
 - [DeploymentGroup](doc/DeploymentGroup.md)
 - [DeveloperType](doc/DeveloperType.md)
 - [Error](doc/Error.md)
 - [Favorite](doc/Favorite.md)
 - [FavoriteGroup](doc/FavoriteGroup.md)
 - [FavoriteGroupVisibility](doc/FavoriteGroupVisibility.md)
 - [FavoriteType](doc/FavoriteType.md)
 - [File](doc/File.md)
 - [FileData](doc/FileData.md)
 - [FileStatus](doc/FileStatus.md)
 - [FileVersion](doc/FileVersion.md)
 - [InlineObject](doc/InlineObject.md)
 - [InlineObject1](doc/InlineObject1.md)
 - [InlineObject10](doc/InlineObject10.md)
 - [InlineObject11](doc/InlineObject11.md)
 - [InlineObject12](doc/InlineObject12.md)
 - [InlineObject2](doc/InlineObject2.md)
 - [InlineObject3](doc/InlineObject3.md)
 - [InlineObject4](doc/InlineObject4.md)
 - [InlineObject5](doc/InlineObject5.md)
 - [InlineObject6](doc/InlineObject6.md)
 - [InlineObject7](doc/InlineObject7.md)
 - [InlineObject8](doc/InlineObject8.md)
 - [InlineObject9](doc/InlineObject9.md)
 - [InlineResponse200](doc/InlineResponse200.md)
 - [InlineResponse2001](doc/InlineResponse2001.md)
 - [InlineResponse2002](doc/InlineResponse2002.md)
 - [InlineResponse2003](doc/InlineResponse2003.md)
 - [InlineResponse2004](doc/InlineResponse2004.md)
 - [InlineResponse2005](doc/InlineResponse2005.md)
 - [InlineResponse2006](doc/InlineResponse2006.md)
 - [InlineResponse2007](doc/InlineResponse2007.md)
 - [InlineResponse401](doc/InlineResponse401.md)
 - [Instance](doc/Instance.md)
 - [InstancePlatforms](doc/InstancePlatforms.md)
 - [LimitedUnityPackage](doc/LimitedUnityPackage.md)
 - [LimitedUser](doc/LimitedUser.md)
 - [LimitedWorld](doc/LimitedWorld.md)
 - [MIMEType](doc/MIMEType.md)
 - [Notification](doc/Notification.md)
 - [NotificationType](doc/NotificationType.md)
 - [Platform](doc/Platform.md)
 - [PlayerModeration](doc/PlayerModeration.md)
 - [PlayerModerationType](doc/PlayerModerationType.md)
 - [ReleaseStatus](doc/ReleaseStatus.md)
 - [Response](doc/Response.md)
 - [Success](doc/Success.md)
 - [UnityPackage](doc/UnityPackage.md)
 - [User](doc/User.md)
 - [UserState](doc/UserState.md)
 - [UserStatus](doc/UserStatus.md)
 - [World](doc/World.md)


## Documentation For Authorization


## apiKeyCookie

- **Type**: API key
- **API key parameter name**: apiKey
- **Location**: 

## apiKeyQuery

- **Type**: API key
- **API key parameter name**: apiKey
- **Location**: URL query string

## authCookie

- **Type**: API key
- **API key parameter name**: auth
- **Location**: 

## authHeader

- **Type**: HTTP basic authentication

## twoFactorAuthCookie

- **Type**: API key
- **API key parameter name**: twoFactorAuth
- **Location**: 


## Author

me@ruby.js.org


